'##################################################################################################
Type TApp
	
	'################################################
	Global Name:String = "Bejeweled Bot"
	Global Version:String = "v0.1"
	
	Global CurList:TList = CreateList()
	Global StartStopKey:Int = KEY_F2
	
	'################################################
	
	Function UpdateKeys()
		Local OldCurList:TList = CurList.Copy()
		ClearList( CurList )
		
		Local I:Int
		For I = 0 To 255
			If (GetAsyncKeyState( I ) & $8000 ) Then
				ListAddLast( CurList, String( I ) )
			EndIf
		Next
		
		For Local A:String = EachIn OldCurList
			If ListContains( CurList, A )
				'Down
				
			Else
				'Release
				If Int( A ) = StartStopKey
					If ProgramStart = 2
						ProgramStart = 1
					EndIf
				EndIf
			EndIf
		Next
		
		For Local B:String = EachIn CurList
			If ListContains( OldCurList, B ) = 0
				'Hit
				If Int( B ) = StartStopKey
					If ProgramStart = 0
						ProgramStart = 2
					ElseIf ProgramStart = 1
						ProgramStart = 0
						Print "Program Stopped!"
					EndIf
				EndIf
			EndIf
		Next
	End Function
	
	Function DebugBoard( Path:String )
		DesktopImage = LoadPixmap( Path )
		Local Temp:TPixmap = CreatePixmap( 8, 8, PF_RGBA8888 )
		
		For Local X:Int = 0 To 7
			For Local Y:Int = 0 To 7
				WritePixel( Temp, X, Y, ReadPixel( DesktopImage, ((X*TSettings.GOWidth)+(TSettings.GOWidth/2))+TSettings.CanvasX, ((Y*TSettings.GOHeight)+(TSettings.GOHeight/2))+TSettings.CanvasY ) )
				TGameObject.Create(  ((X*TSettings.GOWidth)+(TSettings.GOWidth/2))+TSettings.CanvasX, ((Y*TSettings.GOHeight)+(TSettings.GOHeight/2))+TSettings.CanvasY )
			Next
		Next
		
		SavePixmapPNG( Temp, "DebugBoard.png", 0 )
		TApp.Terminate()
	End Function
	
	Function ClickTo( FromGO:TGameObject, ToGO:TGameObject, GO1:TGameObject, GO2:TGameObject, Scenario:Int )
		If FromGo.IsSleeping() Then Return
		If ToGo.IsSleeping() Then Return
		If GO1.IsSleeping() Then Return
		If GO2.IsSleeping() Then Return
		
		FromGo.Sleep()
		ToGo.Sleep()
		GO1.Sleep()
		GO2.Sleep()
		
		TMouse.SetPos( FromGo.X, FromGo.Y )
		Delay TSettings.ActionDelay
		TMouse.Click()
		Delay TSettings.ActionDelay
		TMouse.SetPos( ToGo.X, ToGo.Y )
		Delay TSettings.ActionDelay
		TMouse.Click()
		
		Print FromGo.LocalX + "," + FromGo.LocalY + " => " + ToGo.LocalX + "," + ToGo.LocalY + " - " + Scenario
	End Function
	
	Function Click( GO:TGameObject )
		If GO.IsSleeping() Then Return
		
		GO.Sleep()
		
		TMouse.SetPos( GO.X, GO.Y )
		Delay TSettings.ActionDelay
		TMouse.Click()
		
		Print GO.LocalPos()
	End Function
	
	Function SearchMap( Map:TGameObject[,] )
		For Local X:Int = 0 To 7
			For Local Y:Int = 0 To 7
				
				If Map[X,Y].Color = COLOR_BOX_POWERUP
					Click( Map[X,Y] )
					Delay TSettings.ActionDelay
					If X <= (7-1)
						Click( Map[X+1,Y] )
					Else
						Click( Map[X+1,Y] )
					EndIf
					Continue
				EndIf
				'OXO
				'XOX
				'OXO
				If Y <= (7-2)
					If Map[X,Y].Color = Map[X,Y+2].Color
						
						If X <= (7-1) And Y <= (7-1)
							If Map[X,Y].Color = Map[X+1,Y+1].Color
								ClickTo( Map[X+1, Y+1], Map[X, Y+1], Map[X,Y], Map[X,Y+2], 1 )
								Continue
							EndIf
						EndIf
						
						If X => 1 And Y <= (7-1)
							If Map[X,Y].Color = Map[X-1,Y+1].Color
								ClickTo( Map[X-1, Y+1], Map[X, Y+1], Map[X,Y], Map[X,Y+2], 2 )
								Continue
							EndIf
						EndIf
						
					EndIf
				EndIf
				
				'0X0 X, Y - 2
				'X0X X+-1	,Y - 1
				'0X0 X, Y
				'0X0 X, Y + 1
				'X0X X+-1	,Y + 2
				'0X0 X, Y + 3
				
				If Y <= (7-1)
					If Map[X,Y].Color = Map[X,Y+1].Color
						
						'Backward
						If X => 1 And Y => 1
							If Map[X,Y].Color = Map[X-1,Y-1].Color
								ClickTo( Map[X-1, Y-1], Map[X, Y-1], Map[X,Y], Map[X,Y+1], 14 )
								Continue
							EndIf
						EndIf
						
						If X <= (7-1) And Y => 1
							If Map[X,Y].Color = Map[X+1,Y-1].Color
								ClickTo( Map[X+1, Y-1], Map[X, Y-1], Map[X,Y], Map[X,Y+1], 14 )
								Continue
							EndIf
						EndIf
						
						If Y => 2
							If Map[X,Y].Color = Map[X,Y-2].Color
								ClickTo( Map[X, Y-2], Map[X, Y-1], Map[X,Y], Map[X,Y+1], 14 )
								Continue
							EndIf
						EndIf
						
						'Forward
						If X => 1 And Y <= (7-2)
							If Map[X,Y].Color = Map[X-1,Y+2].Color
								ClickTo( Map[X-1, Y+2], Map[X, Y+2], Map[X,Y], Map[X,Y+1], 3 )
								Continue
							EndIf
						EndIf
						
						If X <= (7-1) And Y <= (7-2)
							If Map[X,Y].Color = Map[X+1,Y+2].Color
								ClickTo( Map[X+1, Y+2], Map[X, Y+2], Map[X,Y], Map[X,Y+1], 4 )
								Continue
							EndIf
						EndIf
						
						'X, Y + 3
						If Y<= (7-3)
							If Map[X,Y].Color = Map[X,Y+3].Color
								ClickTo( Map[X, Y+3], Map[X, Y+2], Map[X,Y], Map[X,Y+1], 5 )
								Continue
							EndIf
						EndIf
						
					EndIf
				EndIf
				
			Next
		Next
		
		For Local Y:Int = 0 To 7
			For Local X:Int = 0 To 7
				
				'OXO
				'XOX
				'OXO
				If X <= (7-2)
					If Map[X,Y].Color = Map[X+2,Y].Color
						
						If X <= (7-1) And Y => 1
							If Map[X,Y].Color = Map[X+1,Y-1].Color
								ClickTo( Map[X+1,Y-1], Map[X+1,Y], Map[X,Y], Map[X+2,Y], 6 )
								Continue
							EndIf
						EndIf
						
						If X <= (7-1) And Y <= (7-1)
							If Map[X,Y].Color = Map[X+1,Y+1].Color
								ClickTo( Map[X+1,Y+1], Map[X+1,Y], Map[X,Y], Map[X+2,Y], 7 )
								Continue
							EndIf
						EndIf
						
					EndIf
				EndIf
				
				'OXOOXO
				'XOXXOX
				'OXOOXO
				If X <= (7-1)
					If Map[X,Y].Color = Map[X+1,Y].Color
						
						'Backward
						If X => 1 And Y => 1
							If Map[X,Y].Color = Map[X-1,Y-1].Color
								ClickTo( Map[X-1,Y-1], Map[X-1,Y], Map[X,Y], Map[X+1,Y], 11 )
								Continue
							EndIf
						EndIf
						
						If X=> 1 And Y <= (7-1)
							If Map[X,Y].Color = Map[X-1,Y+1].Color
								ClickTo( Map[X-1,Y+1], Map[X-1,Y], Map[X,Y], Map[X+1,Y], 12 )
								Continue
							EndIf
						EndIf
						
						If X => 2
							If Map[X,Y].Color = Map[X-2,Y].Color
								ClickTo( Map[X-2,Y], Map[X-1,Y], Map[X,Y], Map[X+1,Y], 13 )
								Continue
							EndIf
						EndIf
						
						'Forward
						If X <= (7-2) And Y => 1
							If Map[X,Y].Color = Map[X+2,Y-1].Color
								ClickTo( Map[X+2,Y-1], Map[X+2,Y], Map[X,Y], Map[X+1,Y], 8 )
								Continue
							EndIf
						EndIf
						
						If X <= (7-2) And Y <= (7-1)
							If Map[X,Y].Color = Map[X+2,Y+1].Color
								ClickTo( Map[X+2,Y+1], Map[X+2,Y], Map[X,Y], Map[X+1,Y], 9 )
								Continue
							EndIf
						EndIf
						
						If X <= (7-3)
							If Map[X,Y].Color = Map[X+3,Y].Color
								ClickTo( Map[X+3,Y], Map[X+2,Y], Map[X,Y], Map[X+1,Y], 10 )
								Continue
							EndIf
						EndIf
						
					EndIf
				EndIf
				
			Next
		Next
	End Function
	
	Function Terminate()
		End
	End Function
	
	'################################################
	
End Type

'##################################################################################################