Const COLOR_ORANGE:Int	= -1678047
Const COLOR_GREEN:Int	= -15686623
Const COLOR_RED:Int		= -452042
Const COLOR_BLUE:Int	= -15692802
Const COLOR_PURPLE:Int	= -1110033
Const COLOR_WHITE:Int	= -2039584
Const COLOR_YELLOW:Int	= -68317

Global COLOR_BURNING_ORANGE:Int	= GenRGB( 231, 107, 37 )
Global COLOR_BURNING_YELLOW:Int	= GenRGB( 255, 246, 37 )
Global COLOR_BURNING_PURPLE:Int	= GenRGB( 240, 18, 240 )
Global COLOR_BURNING_WHITE:Int		= GenRGB( 232, 232, 232 )
Global COLOR_BURNING_BLUE:Int		= GenRGB( 19, 139, 255 )
Global COLOR_BURNING_RED:Int		= GenRGB( 250, 29, 56 )

Global COLOR_5X_BLUE:Int			= GenRGB( 40, 144, 234 )

Global COLOR_4X_BLUE:Int			= GenRGB( 170, 170, 170 )
Global COLOR_4X_ORANGE:Int		= GenRGB( 170, 170, 170 )

Global COLOR_3X_PURPLE:Int		= GenRGB( 204, 17, 203 )

Global COLOR_2X_PURPLE:Int		= GenRGB( 216, 18, 215 )
Global COLOR_2X_RED:Int			= GenRGB( 250, 17, 33 )
Global COLOR_2X_GREEN:Int			= GenRGB( 0, 193, 12 )

Global COLOR_ELECTRIC_RED:Int		= GenRGB( 255, 62, 98 )
Global COLOR_ELECTRIC_GREEN:Int		= GenRGB( 99, 255, 158 )
Global COLOR_ELECTRIC_PURPLE:Int	= GenRGB( 255, 53, 255 )
Global COLOR_ELECTRIC_YELLOW:Int	= GenRGB( 255, 255, 107 )
Global COLOR_ELECTRIC_ORANGE:Int	= GenRGB( 255, 159, 99 )
Global COLOR_ELECTRIC_WHITE:Int	= GenRGB( 255, 255, 255 )
Global COLOR_ELECTRIC_BLUE:Int		= GenRGB( 82, 219, 255 )

Global COLOR_COIN_YELLOW:Int		= GenRGB( 186, 145, 34 )

Global COLOR_BOX_POWERUP:Int		= GenRGB( 180, 174, 146 )

Function GenRgb:Int( red:Int,green:Int,blue:Int  )
	Local RGB:Int = (255 Shl 24) | (Red Shl 16) | (Green Shl 8) | Blue 
	Return rgb
End Function

Type TGameObject
	
	Field Color:Int
	Field X:Int, Y:Int
	Field Sleeping:Int
	Field LocalX:Int, LocalY:Int
	Field SleepTimer:TTimer
	
	Function Create:TGameObject( X:Int, Y:Int )
		Local A:TGameObject = New TGameObject
		A.X = X
		A.Y = Y
		A.Color = ReadPixel( DesktopImage, A.X, A.Y )
		Select A.Color

			'Randoms
			Case COLOR_4X_ORANGE, COLOR_4X_BLUE
				If Rand( 1, 2 ) = 1
					A.Color = COLOR_ORANGE
				Else
					A.Color = COLOR_BLUE
				EndIf
			
			Case COLOR_BOX_POWERUP
				A.SetRandomColor()
			
			'Orange
			Case COLOR_ORANGE, COLOR_BURNING_ORANGE
				A.Color = COLOR_ORANGE
				
			'Yellow
			Case COLOR_YELLOW, COLOR_BURNING_YELLOW, COLOR_COIN_YELLOW, COLOR_ELECTRIC_YELLOW
				A.Color = COLOR_YELLOW
			
			'Purple
			Case COLOR_PURPLE, COLOR_BURNING_PURPLE, COLOR_2X_PURPLE, COLOR_3X_PURPLE, COLOR_ELECTRIC_PURPLE
				A.Color = COLOR_PURPLE
			
			'White
			Case COLOR_WHITE, COLOR_BURNING_WHITE, COLOR_ELECTRIC_WHITE
				A.Color = COLOR_WHITE
			
			'Blue
			Case COLOR_BLUE, COLOR_BURNING_BLUE, COLOR_5X_BLUE, COLOR_ELECTRIC_BLUE
				A.Color = COLOR_BLUE
			
			'Red
			Case COLOR_RED, COLOR_2X_RED, COLOR_ELECTRIC_RED, COLOR_BURNING_RED
				A.Color = COLOR_RED
				
			'Green
			Case COLOR_GREEN, COLOR_ELECTRIC_GREEN, COLOR_2X_GREEN
				A.Color = COLOR_GREEN
			
		End Select
		Return( A )
	End Function
	
	Method SetRandomColor()
		Select Rand( 1, 7 )
			Case 1
				Color = COLOR_ORANGE
			
			Case 2
				Color = COLOR_GREEN
			
			Case 3
				Color = COLOR_RED
			
			Case 4
				Color = COLOR_BLUE
				
			Case 5
				Color = COLOR_PURPLE
				
			Case 6
				Color = COLOR_WHITE
				
			Case 7
				Color = COLOR_YELLOW
				
		End Select
	End Method
	
	Method IsSleeping:Int()
		If SleepTimer <> Null
			If TimerTicks( SleepTimer ) > 0
				StopTimer( SleepTimer )
				SleepTimer = Null
				Return False
			Else
				Return True
			EndIf
		Else
			Return False
		EndIf
	End Method
	
	Method Sleep()
		SleepTimer = CreateTimer( TSettings.SleepDelay/1.0 )
	End Method
	
	Method LocalPos:String()
		Return LocalX + "," + LocalY
	End Method
	
	Function GetRGB(argb:Int,r:Int Var, g:Int Var, b:Int Var)
		Local a:Int=(argb Shr 24) & $ff
		r=(argb Shr 16) & $ff
		g=(argb Shr 8) & $ff
		b=argb & $ff
	End Function

End Type