Const MOUSEEVENTF_ABSOLUTE:Int	= -32768 ' // Use absolute coords
Const MOUSEEVENTF_MOVE:Int   		= 1      ' // Trigger move event
Const MOUSEEVENTF_LEFTDOWN:Int   	= 2     ' // LMB Down
Const MOUSEEVENTF_LEFTUP:Int  		= 4      ' // LMB Up
Const MOUSEEVENTF_RIGHTDOWN:Int  	= 8      ' // RMB Down
Const MOUSEEVENTF_RIGHTUP:Int		= 16     ' // RMB Up
Const MOUSEEVENTF_MIDDLEDOWN:Int 	= 32     ' // MMB Down
Const MOUSEEVENTF_MIDDLEUP:Int	= 64     ' // MMB Up
Const MOUSEEVENTF_WHEEL:Int   		= 128    ' // NT Only: Mouse wheel moved

Type TMouse
	
	Function Click()
		Mouse_Event( MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0 )
		Delay TSettings.ActionDelay
		Mouse_Event( MOUSEEVENTF_LEFTUP, 0, 0, 0, 0 )
	End Function
	
	Function SetPos( X:Int, Y:Int )
		Mouse_Event( MOUSEEVENTF_ABSOLUTE + MOUSEEVENTF_MOVE, AbsMousePosX( X ), AbsMousePosY( Y ), 0, 0 )
	End Function
	
	Function AbsMousePosX:Int( Pos:Int )
		Return 65535.0 * ( Float(Int( Pos ))/Float( TSettings.DesktopWidth ) )
	End Function

	Function AbsMousePosY:Int( Pos:Int )
		Return 65535.0 * ( Float(Int( Pos ))/Float( TSettings.DesktopHeight ) )
	End Function
	
End Type